m4_define([[_HIGHLIGHT_OLDDIVNUM]],m4_divnum())m4_dnl
m4_divert(-1)m4_dnl

m4_dnl Perform CSS-based syntax highlighting of a block of code.
m4_dnl 
m4_dnl Highlight must be installed and the "highlight" CLI command must
m4_dnl be in the current PATH environment variable in order to use this.
m4_dnl 
m4_dnl In your source file, use the following:
m4_dnl 
m4_dnl     m4_include([[highlight.m4]])m4_dnl
m4_dnl     <later...>
m4_dnl     _highlight([[<language>]],[[<code>]])
m4_dnl 
m4_dnl If you get an error message such as:
m4_dnl 
m4_dnl     m4: unexpected end of input, unclosed parenthesis:
m4_dnl 
m4_dnl or:
m4_dnl 
m4_dnl     m4:m4:1: ERROR: end of file in argument list
m4_dnl 
m4_dnl Consider doubling up the quotation of the code text, so that:
m4_dnl     _highlight([[<language>]],[[<code>]])
m4_dnl becomes:
m4_dnl     _highlight([[<language>]],[[[[<code>]]]])
m4_dnl instead.

m4_define([[_highlight]],[[<div class="code"><div class="highlight"><pre>m4_dnl
m4_esyscmd( ( cat << '_HIGHLIGHT_HERE'
$2
_HIGHLIGHT_HERE
) | sed "$ {/^$/d;}" | highlight --syntax=$1 --fragment --inline-css --stdout --out-format=html --style=print )m4_dnl
</pre></div></div>]])

m4_divert(_HIGHLIGHT_OLDDIVNUM)m4_dnl
