m4_define([[_PYGMENT_OLDDIVNUM]],m4_divnum())m4_dnl
m4_divert(-1)m4_dnl

m4_dnl
m4_dnl This is deprecated, but it still works as well as it ever did.
m4_dnl The reason it's deprecated is because the "pygmentize" command
m4_dnl takes a *very* non-trivial length of time to run.  If a source
m4_dnl page file uses it 10 times to generate 10 code blocks, it takes
m4_dnl long enough to be annoying or make you think AMTSWG is hanging.
m4_dnl
m4_dnl Use "highlight.m4" instead of this.  It's about 10 times faster.
m4_dnl
m4_dnl =================================================================
m4_dnl
m4_dnl Pygmentize a block of code so that CSS can style it.
m4_dnl
m4_dnl Pygments must be installed and the "pygmentize" CLI command must
m4_dnl be in the current PATH environment variable in order to use this.
m4_dnl
m4_dnl In your source file, use the following:
m4_dnl
m4_dnl     m4_include([[pygment.m4]])m4_dnl
m4_dnl     <later>
m4_dnl     _pygmentize([[<language>]],[[<code>]])
m4_dnl
m4_dnl If you get an error message such as:
m4_dnl
m4_dnl     m4: unexpected end of input, unclosed parenthesis:
m4_dnl
m4_dnl or:
m4_dnl
m4_dnl     m4:m4:1: ERROR: end of file in argument list
m4_dnl
m4_dnl Consider doubling up the quotation of the code text, so that
m4_dnl "_pygmentize([[<language>]],[[<code>]])" becomes
m4_dnl "_pygmentize([[<language>]],[[[[<code>]]]])" instead.
m4_dnl

m4_define([[_pygmentize]],[[<div class="code">m4_dnl
m4_esyscmd((cat << HERE
$2
HERE
) | pygmentize -f html -l $1)m4_dnl
</div>]])

m4_divert(_PYGMENT_OLDDIVNUM)m4_dnl
